Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/10_SetCredentialsMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/10_SetCredentialsMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/10_SetCredentialsMenuItem.cs	(revision 13718)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Clients.Common;
+using System.Collections.Generic;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class SetCredentialsMenuItem : MenuItemBase {
+    public override string Name {
+      get { return "Set Username / Password..."; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Config" }; }
+    }
+    public override int Position {
+      get { return 10; }
+    }
+    public override string ToolTipText {
+      get { return "Set username and password for accessing HeuristicLab services"; }
+    }
+
+    public override void Execute() {
+      using (var dialog = new PasswordDialog()) {
+        dialog.ShowDialog(MainForm);
+      }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/20_SetProblemMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/20_SetProblemMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/20_SetProblemMenuItem.cs	(revision 13718)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class SetProblemMenuItem : MenuItemBase {
+    public override void Execute() {
+      MainForm.ShowContent(MainForm.ExpertSystem.Problem, true);
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Config" }; }
+    }
+
+    public override string Name {
+      get { return "Problem Instance"; }
+    }
+
+    public override string ToolTipText {
+      get { return "Select the problem instance that you want to solve."; }
+    }
+
+    public override int Position {
+      get { return 20; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/30_DownloadFromOkbMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/30_DownloadFromOkbMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/30_DownloadFromOkbMenuItem.cs	(revision 13718)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class DownloadFromOKBMenuItem : MenuItemBase {
+    public override void Execute() {
+      MainForm.ExpertSystem.UpdateKnowledgeBaseAsync();
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Config" }; }
+    }
+
+    public override string Name {
+      get { return "Download from OKB"; }
+    }
+
+    public override int Position {
+      get { return 30; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/40_AdministerOkbMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/40_AdministerOkbMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/0_Config/40_AdministerOkbMenuItem.cs	(revision 13718)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Clients.OKB;
+using HeuristicLab.Clients.OKB.Administration;
+using HeuristicLab.MainForm;
+using System.Collections.Generic;
+using System.Windows.Forms;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class AdministerOKBMenuItem : MenuItemBase {
+    public override string Name {
+      get { return "Administer OKB"; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Config" }; }
+    }
+    public override int Position {
+      get { return 40; }
+    }
+
+    public override void Execute() {
+      if (OKBRoles.CheckAdminUserPermissions()) {
+        MainFormManager.MainForm.ShowContent(AdministrationClient.Instance);
+      } else {
+        MessageBox.Show("You don't have the permissions for administrating the OKB.", "Security check failed", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+      }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/100_Understanding/110_ProblemInstanceMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/100_Understanding/110_ProblemInstanceMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/100_Understanding/110_ProblemInstanceMenuItem.cs	(revision 13718)
@@ -0,0 +1,45 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class ProblemInstanceMenuItem : MenuItemBase {
+    public override void Execute() {
+      var view = MainForm.Views.OfType<UnderstandingProblemInstanceView>().FirstOrDefault();
+      if (view != null) view.Show();
+      else MainForm.ShowContent(MainForm.ExpertSystem, typeof(UnderstandingProblemInstanceView));
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Understanding" }; }
+    }
+
+    public override string Name {
+      get { return "Problem Instance"; }
+    }
+
+    public override int Position {
+      get { return 110; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/100_Understanding/120_SolutionsMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/100_Understanding/120_SolutionsMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/100_Understanding/120_SolutionsMenuItem.cs	(revision 13718)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class SolutionSimilarityMenuItem : MenuItemBase {
+    public override void Execute() {
+      throw new NotImplementedException();
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Understanding" }; }
+    }
+
+    public override string Name {
+      get { return "Solutions"; }
+    }
+
+    public override int Position {
+      get { return 120; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/210_SolverMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/210_SolverMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/210_SolverMenuItem.cs	(revision 13718)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class SolverMenuItem : MenuItemBase {
+    public override void Execute() {
+      throw new NotImplementedException();
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Solving" }; }
+    }
+
+    public override string Name {
+      get { return "Solver"; }
+    }
+
+    public override int Position {
+      get { return 210; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/300_Learning/310_AlgorithmInstancesMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/300_Learning/310_AlgorithmInstancesMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/300_Learning/310_AlgorithmInstancesMenuItem.cs	(revision 13718)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class AlgorithmInstancesMenuItem : MenuItemBase {
+    public override void Execute() {
+      throw new NotImplementedException();
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Learning" }; }
+    }
+
+    public override string Name {
+      get { return "Algorithm Instances"; }
+    }
+
+    public override int Position {
+      get { return 310; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/910_NewCSharpScriptMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/910_NewCSharpScriptMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/910_NewCSharpScriptMenuItem.cs	(revision 13718)
@@ -0,0 +1,80 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Scripting;
+using System.Collections.Generic;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class NewCSharpScriptMenuItem : MenuItemBase {
+    #region CodeTemplate
+    private static readonly string CodeTemplate = @"
+// use 'vars' to access variables in the script's variable store (e.g. vars.x = 5)
+// use 'vars[string]' to access variables via runtime strings (e.g. vars[""x""] = 5)
+// use 'vars.Contains(string)' to check if a variable exists
+// use 'vars.Clear()' to remove all variables
+// use 'foreach (KeyValuePair<string, object> v in vars) { ... }' to iterate over all variables
+// use 'variables' to work with IEnumerable<T> extension methods on the script's variable store
+
+using System;
+using System.Linq;
+using System.Collections.Generic;
+
+using QueryClient = HeuristicLab.Clients.OKB.Query.QueryClient;
+using RunCreationClient = HeuristicLab.Clients.OKB.RunCreation.RunCreationClient;
+using AdministrationClient = HeuristicLab.Clients.OKB.Administration.AdministrationClient;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Collections;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.OptimizationExpertSystem;
+using HeuristicLab.OptimizationExpertSystem.Common;
+using HeuristicLab.Random;
+
+public class MyScript : HeuristicLab.Scripting.CSharpScriptBase {
+  public ExpertSystem Instance { get { return ((OptimizationExpertSystem)HeuristicLab.MainForm.MainFormManager.MainForm).ExpertSystem; } }
+
+  public override void Main() {
+    // type your code here
+  }
+
+  // implement further classes and methods
+
+}";
+    #endregion
+
+    public override void Execute() {
+      MainForm.ShowContent(new CSharpScript(CodeTemplate));
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Tools", "C# Script" }; }
+    }
+
+    public override string Name {
+      get { return "New"; }
+    }
+
+    public override int Position {
+      get { return 910; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/920_OpenCSharpScriptMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/920_OpenCSharpScriptMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/920_OpenCSharpScriptMenuItem.cs	(revision 13718)
@@ -0,0 +1,51 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Scripting;
+using System.Collections.Generic;
+using System.Windows.Forms;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class OpenCSharpScriptMenuItem : MenuItemBase {
+    public override void Execute() {
+      using (var dialog = new OpenFileDialog()) {
+        dialog.Filter = "HL Files|*.hl|All Files|*.*";
+        if (dialog.ShowDialog(MainForm) != DialogResult.OK) return;
+        var script = ContentManager.Load(dialog.FileName) as CSharpScript;
+        if (script != null) MainForm.ShowContent(script);
+        else MessageBox.Show("HL Files is not a C# script.", "Wrong File", MessageBoxButtons.OK, MessageBoxIcon.Error);
+      }
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Tools", "C# Script" }; }
+    }
+
+    public override string Name {
+      get { return "Open"; }
+    }
+
+    public override int Position {
+      get { return 920; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/930_SaveCSharpScriptMenuItem.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/930_SaveCSharpScriptMenuItem.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/900_Tools/930_SaveCSharpScriptMenuItem.cs	(revision 13718)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.MainForm;
+using HeuristicLab.Scripting;
+using System;
+using System.Collections.Generic;
+using System.Windows.Forms;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class SaveCSharpScriptMenuItem : MenuItemBase {
+    protected override void OnActiveViewChanged(object sender, EventArgs e) {
+      base.OnActiveViewChanged(sender, e);
+      var contentView = MainForm.ActiveView as IContentView;
+      ToolStripItem.Enabled = (contentView != null && contentView.Content is CSharpScript);
+    }
+
+    public override void Execute() {
+      using (var dialog = new SaveFileDialog()) {
+        dialog.Filter = "HL Files|*.hl";
+        if (dialog.ShowDialog(MainForm) != DialogResult.OK) return;
+        ContentManager.Save((CSharpScript)((IContentView)MainForm.ActiveView).Content, dialog.FileName, true);
+      }
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Tools", "C# Script" }; }
+    }
+
+    public override string Name {
+      get { return "Save"; }
+    }
+
+    public override int Position {
+      get { return 930; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/MenuItemBase.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/MenuItemBase.cs	(revision 13718)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/MenuItemBase.cs	(revision 13718)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal abstract class MenuItemBase : MenuItem, IOptimizationExpertSystemUi {
+    public OptimizationExpertSystem MainForm {
+      get { return (OptimizationExpertSystem)HeuristicLab.MainForm.MainFormManager.MainForm; }
+    }
+  }
+}
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/OptimizationExpertSystem.Designer.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/OptimizationExpertSystem.Designer.cs	(revision 13713)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/OptimizationExpertSystem.Designer.cs	(revision 13718)
@@ -32,6 +32,6 @@
       this.ClientSize = new System.Drawing.Size(624, 412);
       this.Name = "OptimizationExpertSystem";
-      this.Text = "Optimization Expert System (OES)";
-      this.Title = "Optimization Expert System (OES)";
+      this.Text = "Optimization Knowledge Center (OKC)";
+      this.Title = "Optimization Knowledge Center (OKC)";
       this.Load += new System.EventHandler(this.OptimizationExpertSystem_Load);
       this.ResumeLayout(false);
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Plugin.cs.frame
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Plugin.cs.frame	(revision 13713)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Plugin.cs.frame	(revision 13718)
@@ -43,6 +43,6 @@
   }
 
-  [Application("Optimization Expert System", "HeuristicLab Optimization Expert System 3.3.13.$WCREV$")]
-  internal class HeuristicLabOptimizationExpertSystemApplication : ApplicationBase {
+  [Application("Optimization Knowledge Center", "HeuristicLab Optimization Knowledge Center 3.3.13.$WCREV$")]
+  internal class HeuristicLabOptimizationKnowledgeCenterApplication : ApplicationBase {
     public override void Run(ICommandLineArgument[] args) {
       HeuristicLab.MainForm.WindowsForms.MainForm mainForm = new OptimizationExpertSystem(typeof(IOptimizationExpertSystemUi));
